//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     LimeGreen
#property indicator_color2     PaleVioletRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_level1     0

//
//
//
//
//

extern double BoxStartPeriod =  6.5;
extern double BoxEndPeriod   = 25.0;
extern int    Steps          = 100;


//
//
//
//
//

double no[];
double kr[];
double step;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(0);      
      SetIndexBuffer(0,kr); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexEmptyValue(0,0.00); SetIndexLabel(0,"XO Up");
      SetIndexBuffer(1,no); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexEmptyValue(1,0.00); SetIndexLabel(1,"XO Down");
         Steps = MathMax(1,MathMin(Steps,100));
         step  = (BoxEndPeriod-BoxStartPeriod)/(1.0*Steps);

   //
   //
   //
   //
   //
      
   IndicatorShortName("XO ("+DoubleToStr(BoxStartPeriod,2)+","+DoubleToStr(BoxEndPeriod,2)+","+Steps+")");
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][400];
#define _hi 0
#define _lo 1
#define _kr 2
#define _no 3

int start()
{
   int i,k,r,instanceNo,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           double pipMultiplier = 1; if(Digits==3 || Digits==5) pipMultiplier = 10;
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   { 
      kr[i] = 0;
      no[i] = 0;
      for (k=0, instanceNo=0; k<Steps; k++, instanceNo+=4)
      {
         double diff = (BoxStartPeriod+step*k)*Point*pipMultiplier;
         if (i>=(Bars-2)) { work[r-1][instanceNo+_hi]=Close[i]; work[r-1][instanceNo+_lo]=Close[i]; continue; }
      
         //
         //
         //
         //
         //
         
         double cur  = Close[i];
                work[r][instanceNo+_hi] = work[r-1][instanceNo+_hi];
                work[r][instanceNo+_lo] = work[r-1][instanceNo+_lo];
                work[r][instanceNo+_kr] = work[r-1][instanceNo+_kr];
                work[r][instanceNo+_no] = work[r-1][instanceNo+_no];

                if (cur > (work[r][instanceNo+_hi]+diff)) 
                {
                     work[r][instanceNo+_hi] = cur;
                     work[r][instanceNo+_lo] = cur-diff;
                     work[r][instanceNo+_kr] = work[r-1][instanceNo+_kr]+1;
                     work[r][instanceNo+_no] = 0;
                }
                if (cur < (work[r][instanceNo+_lo]-diff)) 
                {
                     work[r][instanceNo+_lo] = cur;
                     work[r][instanceNo+_hi] = cur+diff;
                     work[r][instanceNo+_no] = work[r-1][instanceNo+_no]-1;
                     work[r][instanceNo+_kr] = 0;
                }
                if (work[r][instanceNo+_kr]>0) kr[i] += 1;
                if (work[r][instanceNo+_no]<0) no[i] -= 1;
      }                
   }
   return(0);
}

